SystemOrganization addCategory: #TusLibros!

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:39'!
checkingOutAnEmptyCartErrorDescription
	^ 'No se puede realizar el cobro de un carrito vaco.'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:38'!
checkOut: aShoppingCart
	(aShoppingCart isEmpty) ifTrue: [self error: self class checkingOutAnEmptyCartErrorDescription] ifFalse: [self shouldBeImplemented]! !

Object subclass: #ShoppingCart
	instanceVariableNames: 'catalog productsBag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:45'!
addingAProductNotInCatalogErrorDescription
	^ 'No se puede agregar un producto que no exista en el catlogo'.! !

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:04'!
addingNonPositiveQuantityErrorDescription
	^ 'No se puede agregar al carrito una cantidad menor que 1'.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:17'!
addProduct: aProductID
	(catalog includesKey: aProductID) ifTrue: [productsBag add: aProductID] ifFalse: [self error: self class addingAProductNotInCatalogErrorDescription ].! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:37'!
containsProduct: aProductID
	^ productsBag includes: aProductID "Association: (Association new key: aProductID value: aQuantity)."! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:55'!
initializeWithCatalog: aPublishersCatalog
	super initialize.
	productsBag := Bag new.
	catalog := aPublishersCatalog.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:39'!
isEmpty
	"Devuelve la cantidad de items en el carrito"
	^ productsBag isEmpty! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:20'!
size
	"Devuelve la cantidad de items en el carrito"
	^ productsBag size! !

TestCase subclass: #TusLibrosTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:09'!
anEmptyBookCart
	^ ShoppingCart new initializeWithCatalog: self anEmptyPublisherCatalog! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:14'!
anEmptyPublisherCatalog
	^ Dictionary new.! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 19:56'!
test01CartShouldBeEmptyAfterCreation
	"Luego de crear el carrito el mismo debe estar vaco"	
	self assert: self anEmptyBookCart size=0! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:20'!
test02AfterAddingABookCartMustHaveThatBook

	|aBookID aBookPrice aBookCart aBookCatalog|
	aBookID := 1.
	aBookPrice := 10.4.
	aBookCatalog := self anEmptyPublisherCatalog.
	aBookCatalog add:  (Association new key: aBookID value: aBookPrice).
	aBookCart := ShoppingCart new initializeWithCatalog: aBookCatalog.
	aBookCart addProduct: aBookID.
	self assert: (aBookCart containsProduct: aBookID).
	self assert: aBookCart size = 1.

	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:55'!
test03AddingABookFromAnotherPublisherShouldRaiseAnException
	"No puedo agregar libros que no sean de mi editorial"
	|aBookID aBookCart |
	aBookID := 1.
	aBookCart := self anEmptyBookCart .
	self
		should: [ aBookCart addProduct: aBookID ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = ShoppingCart addingAProductNotInCatalogErrorDescription. 
			self assert: aBookCart isEmpty].
	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:34'!
test04CheckingOutAnEmptyCartShouldRaiseAnError	
	"No se puede cobrar un carrito vaco"
	self
		should: [ (Cashier new) checkOut: self anEmptyBookCart ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = Cashier checkingOutAnEmptyCartErrorDescription ]! !
